<?php
declare(strict_types = 1);
namespace app\cms\controller;
use app\common\hook\NodeFormat;
use think\facade\Event;
use think\facade\View;

class Part extends Base
{
    protected $ArticleModel;
    protected $PartList;
    protected $Read;
    protected $conf;
    protected function initialize()
    {
        parent::initialize();
        $this->BaseModel('Part','model','cms');
        $this->BaseModel('Article','ArticleModel','cms');
        $this->list_base['base_part'] = 'cms:part';
        $this->GetConf();
        $this->GetPartList();
    }

    protected function ReadCallback($data){
        if(empty($data) || $data['status'] != '1'){
             ResClient('内容不存在','0','',GetEruUrl('home/Index/index'));
        }
        if(!empty($data['jumpurl'])){
            ResClient('','0','',$data['jumpurl'],'3',false,'jump.htm',302);
            return redirect($data['jumpurl']);
        }
        $this->EditTdk($data);
        $this->GetRead($data['id']);
        $listdb = $this->GetArticleList();
        View::assign(['listdb' => $listdb]);
        return $this->Read;
    }

    protected function GetListDbCallback($data){
        $data = NodeFormat::toList($data);
        return $data;
    }
    protected function GetConf(){
        $res = Event::trigger('Mod',['type' => 'GetMod','data' => ['mod' => 'part','model' => 'cms']]);
        if($res['0']['code'] != '1'){
            ResClient($res['0']['msg'],'0');
        }
        $this->conf = $res['0']['data'];
        switch ($this->conf['pages']){
            case '1':
                $this->list_base['page'] = false;
                break;
            case '2':
                $this->list_base['page'] = false;
                $this->list_base['fold'] = true;
                break;
        }
    }

    //  分配TDK
    protected function EditTdk($data){
        $this->webdb['web_title'] = "{$data['title']}_{$this->webdb['web_title']}";
        $this->webdb['web_keywords'] = $data['keywords'] ?: $this->webdb['web_keywords'];
        $this->webdb['web_description'] = $data['description'] ?: $this->webdb['web_description'];
        View::assign(['webdb' => $this->webdb]);
    }
    //  查询栏目列表
    protected function GetPartList()
    {
        $this->PartList = $this->model->GetList(['status' => '1'],$this->list_base['page']);
        $this->PartList = $this->model->UntList($this->PartList);
        $this->PartList = NodeFormat::toList($this->PartList);
        $this->PartList = FileEditAdd($this->PartList,false,true);
        View::assign(['partlist' => $this->PartList]);
    }
    //  查询当前栏目
    protected function GetRead($id)
    {
        $this->Read = DelFile($this->PartList,'id',$id);
        $this->Read = $this->Read['0'];
        $this->Read['node'] = NodeFormat::toLayer($this->PartList,$this->Read['id']);
        $_menu = NodeFormat::getParents($this->PartList,$this->Read['id']);
        foreach ($_menu as $v){
            if(empty($this->Read['banner'])){
                $this->Read['banner'] = $v['banner'] ?: $this->Read['banner'];
            }
            if(empty($this->Read['logo'])){
                $this->Read['logo'] = $v['logo'] ?: $this->Read['logo'];
            }
            if(empty($this->Read['list_num'])){
                $this->Read['list_num'] = $v['list_num'] ?: $this->Read['list_num'];
            }
            if(empty($this->Read['title_num'])){
                $this->Read['title_num'] = $v['title_num'] ?: $this->Read['title_num'];
            }
            if(empty($this->Read['cont_num'])){
                $this->Read['cont_num'] = $v['cont_num'] ?: $this->Read['cont_num'];
            }
            if(empty($this->Read['temp_late'])){
                $this->Read['temp_late'] = $v['temp_late'] ?: $this->Read['temp_late'];
            }
        }
        $this->Read['temp_late'] = $this->Read['temp_late'] ?: 'default/template/cms/article_list/default';
        $this->Read['temp_late'] = "public/home/{$this->Read['temp_late']}.htm";
        View::assign(['menu' => $_menu]);
    }
    //  查询内容列表
    protected function GetArticleList(){
        $_fid = [];
        if(!empty($this->Read['node'])){
            $_fid = NodeFormat::getChildsId($this->PartList,$this->Read['id']);
        }
        array_push($_fid,$this->Read['id']);
        $res = $this->ArticleModel->GetList(['fid' => $_fid,'order' => $this->Read['articleorder'] ?: '','limit' => $this->Read['list_num'] ?: '']);
        if($res['total'] > '0'){
            $res['data'] = $this->ArticleModel->UntList($res['data']);
            foreach ($res['data'] as $k => $v){
                if(!empty($this->Read['title_num'])){
                    $v['title'] = GetWordNum($v['title'],$this->Read['title_num']);
                }
                if(!empty($this->Read['cont_num'])){
                    $v['description'] = GetWordNum($v['description'],$this->Read['cont_num']);
                }
                $res['data'][$k] = $v;
            }
        }
        return $res;
    }

}